function get_chmod_value ( permissions ) {
 var chmod = 0;
 if (permissions.substr (1, 1) != '-') {
  chmod += 400;
 }
 if (permissions.substr (2, 1) != '-') {
  chmod += 200;
 }
 if (permissions.substr (3, 1) != '-') {
  chmod += 100;
 }
 if (permissions.substr (4, 1) != '-') {
  chmod += 40;
 }
 if (permissions.substr (5, 1) != '-') {
  chmod += 20;
 }
 if (permissions.substr (6, 1) != '-') {
  chmod += 10;
 }
 if (permissions.substr (7, 1) != '-') {
  chmod += 4;
 }
 if (permissions.substr (8, 1) != '-') {
  chmod += 2;
 }
 if (permissions.substr (9, 1) != '-') {
  chmod += 1;
 }
 if (chmod < 100 && chmod >= 10) {
  chmod = '0' + chmod;
 }
 if (chmod < 10) {
  chmod = '00' + chmod;
 }
 return chmod;
}

function get_permissions_string ( first_letter, chmod_value ) {
 var permissions = first_letter;
 var temp_string = '';

 if (chmod_value >= 100) {
  temp_string += chmod_value;
 }
 if (chmod_value < 100 && chmod_value >= 10) {
  temp_string = '0' + chmod_value;
 }
 if (chmod_value < 10) {
  temp_string = '00' + chmod_value;
 }

 var own = temp_string.substr (0, 1);
 var grp = temp_string.substr (1, 1);
 var pub = temp_string.substr (2, 1);

 permissions += own & 4 ? 'r' : '-';
 permissions += own & 2 ? 'w' : '-';
 permissions += own & 1 ? 'x' : '-';
 permissions += grp & 4 ? 'r' : '-';
 permissions += grp & 2 ? 'w' : '-';
 permissions += grp & 1 ? 'x' : '-';
 permissions += pub & 4 ? 'r' : '-';
 permissions += pub & 2 ? 'w' : '-';
 permissions += pub & 1 ? 'x' : '-';

 return permissions;
}
